USE DemoProgramming
go

/* 
	MICKEY NOTES 
	Turn on Execution Plans
	Run Query, then Explain

*/

SET NOCOUNT ON
SELECT COUNT(*) RecordsToInsert FROM dbo.TestData 

CREATE TABLE dbo.ExTestData
(
	TestDataID int  NOT NULL,
	SomeText varchar(5) NULL,
	SomeDate date NULL,
	SomeDateText varchar(10) NULL,
	SomeTextNumber int NULL
)

DECLARE @ExTableVar AS TABLE
(TestDataID  INTEGER
,SomeText varchar(5)
,SomeDate date
,SomeDateText varchar(10)
,SomeTextnumber int
)

CREATE TABLE #ExTempTable
(TestDataID  INTEGER
,SomeText varchar(5)
,SomeDate date
,SomeDateText varchar(10)
,SomeTextnumber int
)




PRINT ' ***** Insert into Table Variable ***** '
INSERT INTO @ExTableVar
SELECT
    TestDataID
   ,SomeText
   ,SomeDate
   ,SomeDateText
   ,SomeTextNumber
FROM
    dbo.TestData

PRINT ' ***** Insert into Temp Table ***** '
INSERT INTO #ExTempTable
SELECT
    TestDataID
   ,SomeText
   ,SomeDate
   ,SomeDateText
   ,SomeTextNumber
FROM
    dbo.TestData


PRINT ' ***** Insert into Materialized Table ***** '
INSERT INTO dbo.ExTestData
SELECT
    TestDataID
   ,SomeText
   ,SomeDate
   ,SomeDateText
   ,SomeTextNumber
FROM
    dbo.TestData

SET STATISTICS IO ON
SET STATISTICS TIME ON


PRINT ' ***** Select into Temp Table ***** '
SELECT * FROM #ExTempTable WHERE SomeDate = CONVERT(date,'1/1/2012')

PRINT ' ***** Select into Materialized Table ***** '
SELECT * FROM dbo.ExTestData WHERE SomeDate = CONVERT(date,'1/1/2012')

PRINT ' ***** Select from Table Variable ***** '
SELECT * FROM @ExTableVar WHERE SomeDate = CONVERT(date,'1/1/2012')

SET STATISTICS IO OFF
SET STATISTICS TIME OFF

DROP TABLE #ExTempTable
DROP TABLE dbo.ExTestData
